﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ILNumerics;

namespace Particle2DBox
{

    /// <summary>
    /// Example ILNumerics Computing Module
    /// </summary>
    /// <remarks>This is an example showing how to write and use simple ILNumerics Computing Modules.
    /// The purpose of the code in here is demonstration only. You may alter, use or delete any parts of it as you will.</remarks>
    public class Computing_Module1 : ILMath
    {

        public static ILArray<double> CalcWF(int EVXID, int EVYID, double LX, double LY, int MeshSize)
        {

            ILArray<double> X = linspace<double>(0, LX, MeshSize);
            ILArray<double> Y = linspace<double>(0, LY, MeshSize);


            ILArray<double> Y2d = 1;
            ILArray<double> X2d = meshgrid(X, Y, Y2d);

            ILArray<double> Z = sqrt(4.0 / LX / LY) * sin(EVXID * pi * X2d / LX) * sin(EVYID * pi * Y2d / LY);

            return Z.Concat(X2d,2).Concat(Y2d,2);
        }

        public static ILArray<double> CalcDens(int EVXID, int EVYID, double LX, double LY, int MeshSize)
        {

            ILArray<double> X = linspace<double>(0, LX, MeshSize);
            ILArray<double> Y = linspace<double>(0, LY, MeshSize);

            ILArray<double> Y2d = 1;
            ILArray<double> X2d = meshgrid(X, Y, Y2d);

            ILArray<double> Z = 4.0 / LX / LY * pow( ( sin(EVXID * pi * X2d / LX) * sin(EVYID * pi * Y2d / LY) ),2);

            return Z.Concat(X2d, 2).Concat(Y2d, 2);
        }

    }

}
