﻿using ILNumerics;
using ILNumerics.Drawing;
using ILNumerics.Drawing.Plotting;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Particle2DBox
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            var EVXID = 1;
            var EVYID = 1;
            var MeshSize = 100;
            var LX = 1.0;
            var LY = 1.0;

            InitializeComponent();
            InitializeWFPanel(EVXID,EVYID,LX,LY,MeshSize);
            InitializeDensPanel(EVXID,EVYID,LX,LY,MeshSize);

            numericUpDown1.ValueChanged += Changed;
            numericUpDown2.ValueChanged += Changed;
            numericUpDown3.ValueChanged += Changed;
            textBox1.TextChanged += Changed;
        }

        private void InitializeWFPanel(int EVXID, int EVYID, double LX, double LY, int MeshSize)
        {
            ILArray<float> XYZ = ILMath.tosingle(Computing_Module1.CalcWF(EVXID, EVYID, LX, LY, MeshSize));
  
            ilPanel1.Scene = 
                new ILScene { 
                    new ILPlotCube (twoDMode : false) { 
                        new ILSurface (XYZ) {
                            new ILColorbar()
                        }
                    } 
                };
        }

        private void InitializeDensPanel(int EVXID, int EVYID, double LX, double LY, int MeshSize)
        {
            ILArray<float> XYZ = ILMath.tosingle(Computing_Module1.CalcDens(EVXID, EVYID, LX, LY, MeshSize));

            ilPanel2.Scene = 
                new ILScene { 
                    new ILPlotCube (twoDMode : false) { 
                        new ILSurface (XYZ) {
                            new ILColorbar()
                        }
                    } 
                };
        }

        private void Update(int EVXID, int EVYID, double LX = 1.0, double LY = 1.0, int MeshSize = 100)
        {
            ILArray<float> XYZ = ILMath.tosingle(Computing_Module1.CalcWF(EVXID, EVYID, LX, LY, MeshSize));
            ilPanel1.Scene.First<ILSurface>().UpdateColormapped(XYZ);
            ilPanel1.Scene.First<ILPlotCube>().Reset();
            ilPanel1.Refresh();

            XYZ = ILMath.tosingle(Computing_Module1.CalcDens(EVXID, EVYID, LX, LY, MeshSize));
            ilPanel2.Scene.First<ILSurface>().UpdateColormapped(XYZ);
            ilPanel2.Scene.First<ILPlotCube>().Reset();
            ilPanel2.Refresh();
        }
        
        private void Changed(object sender, EventArgs e)
        {

            double a = 1.0;

            if ( double.TryParse(textBox1.Text, out a))
            {
                Update((int)numericUpDown1.Value, (int)numericUpDown2.Value, LY : a, MeshSize : (int) numericUpDown3.Value);
            } 
            else
            {
                MessageBox.Show("Need a floating point in this field");
            }
        }

    }
}
